$(() => {
const sendRequest = function (value) {
const invalidEmail = 'test@dx-email.com';
const d = $.Deferred();
setTimeout(() => {
d.resolve(value !== invalidEmail);
}, 1000);
return d.promise();
};
const changePasswordMode = function (name) {
const editor = formWidget.getEditor(name);
editor.option('mode', editor.option('mode') === 'text' ? 'password' : 'text');
};
const formWidget = $('#form').dxForm({
formData,
readOnly: false,
showColonAfterLabel: true,
showValidationSummary: true,
validationGroup: 'customerData',
onOptionChanged: (e) => {
if (e.name === 'isDirty') {
const resetButton = formWidget.getButton('Reset');
resetButton.option('disabled', !e.value);
}
},
items: [{
itemType: 'group',
caption: 'Credentials',
items: [{
dataField: 'Email',
editorOptions: {
valueChangeEvent: 'keyup',
},
validationRules: [{
type: 'required',
message: 'Email is required',
}, {
type: 'email',
message: 'Email is invalid',
}, {
type: 'async',
message: 'Email is already registered',
validationCallback(params) {
return sendRequest(params.value);
},
}],
}, {
dataField: 'Password',
editorOptions: {
mode: 'password',
valueChangeEvent: 'keyup',
onValueChanged() {
const editor = formWidget.getEditor('ConfirmPassword');
if (editor.option('value')) {
editor.element().dxValidator('validate');
}
},
buttons: [{
name: 'password',
location: 'after',
options: {
stylingMode: 'text',
icon: 'eyeopen',
onClick: () => changePasswordMode('Password'),
},
}],
},
validationRules: [{
type: 'required',
message: 'Password is required',
}],
}, {
name: 'ConfirmPassword',
dataField: 'ConfirmPassword',
label: {
text: 'Confirm Password',
},
editorType: 'dxTextBox',
editorOptions: {
mode: 'password',
valueChangeEvent: 'keyup',
buttons: [{
name: 'password',
location: 'after',
options: {
icon: 'eyeopen',
stylingMode: 'text',
onClick: () => changePasswordMode('ConfirmPassword'),
},
}],
},
validationRules: [{
type: 'required',
message: 'Confirm Password is required',
}, {
type: 'compare',
message: "'Password' and 'Confirm Password' do not match",
comparisonTarget() {
return formWidget.option('formData').Password;
},
}],
}],
}, {
itemType: 'group',
caption: 'Personal Data',
items: [{
dataField: 'Name',
editorOptions: {
valueChangeEvent: 'keyup',
},
validationRules: [{
type: 'required',
message: 'Name is required',
}, {
type: 'pattern',
pattern: '^[^0-9]+$',
message: 'Do not use digits in the Name',
}],
}, {
dataField: 'Date',
editorType: 'dxDateBox',
label: {
text: 'Date of birth',
},
editorOptions: {
placeholder: 'Birth Date',
acceptCustomValue: false,
openOnFieldClick: true,
},
validationRules: [{
type: 'required',
message: 'Date of birth is required',
}, {
type: 'range',
max: new Date().setFullYear(new Date().getFullYear() - 21),
message: 'You must be at least 21 years old',
}],
}, {
dataField: 'VacationDates',
editorType: 'dxDateRangeBox',
label: {
text: 'Vacation Dates',
},
validationRules: [{
type: 'custom',
validationCallback: ({ value }) => {
const [startDate, endDate] = value;
if (startDate === null || endDate === null) {
return true;
}
const millisecondsPerDay = 24 * 60 * 60 * 1000;
const daysDifference = Math.abs((endDate - startDate) / millisecondsPerDay);
return daysDifference < 25;
},
message: 'The vacation period must not exceed 25 days',
}, {
type: 'custom',
validationCallback: ({ value }) => {
const [startDate, endDate] = value;
if (startDate === null && endDate === null) {
return true;
}
return startDate !== null && endDate !== null;
},
message: 'Both start and end dates must be selected',
}],
editorOptions: {
startDatePlaceholder: 'Start Date',
endDatePlaceholder: 'End Date',
acceptCustomValue: false,
},
}],
}, {
itemType: 'group',
caption: 'Billing address',
items: [{
dataField: 'Country',
editorType: 'dxSelectBox',
editorOptions: {
dataSource: countries,
},
validationRules: [{
type: 'required',
message: 'Country is required',
}],
}, {
dataField: 'City',
editorType: 'dxAutocomplete',
editorOptions: {
dataSource: cities,
minSearchLength: 2,
valueChangeEvent: 'keyup',
},
validationRules: [{
type: 'pattern',
pattern: '^[^0-9]+$',
message: 'Do not use digits in the City name',
}, {
type: 'stringLength',
min: 2,
message: 'City must have at least 2 symbols',
}, {
type: 'required',
message: 'City is required',
}],
}, {
dataField: 'Address',
editorOptions: {
valueChangeEvent: 'keyup',
},
validationRules: [{
type: 'required',
message: 'Address is required',
}],
}, {
dataField: 'Phone',
helpText: 'Enter the phone number in USA phone format',
editorOptions: {
mask: '+1 (X00) 000-0000',
maskRules: {
X: /[02-9]/,
},
maskInvalidMessage: 'The phone must have a correct USA phone format',
valueChangeEvent: 'keyup',
},
validationRules: [{
type: 'pattern',
pattern: /^[02-9]\d{9}$/,
message: 'The phone must have a correct USA phone format',
}],
}],
}, {
itemType: 'group',
cssClass: 'last-group',
colCountByScreen: {
xs: 2,
sm: 2,
md: 2,
lg: 2,
},
items: [{
dataField: 'Accepted',
label: {
visible: false,
},
editorOptions: {
width: 270,
text: 'I agree to the Terms and Conditions',
},
validationRules: [{
type: 'compare',
comparisonTarget() { return true; },
message: 'You must agree to the Terms and Conditions',
}],
}, {
itemType: 'group',
cssClass: 'buttons-group',
colCountByScreen: {
xs: 2,
sm: 2,
md: 2,
lg: 2,
},
items: [{
itemType: 'button',
name: 'Reset',
buttonOptions: {
onClick: () => {
formWidget.reset();
},
icon: 'refresh',
text: 'Reset',
disabled: true,
width: '120px',
},
}, {
itemType: 'button',
buttonOptions: {
text: 'Register',
type: 'default',
useSubmitBehavior: true,
width: '120px',
},
}],
}],
}],
}).dxForm('instance');
$('#form-container').on('submit', (e) => {
DevExpress.ui.notify({
message: 'You have submitted the form',
position: {
my: 'center top',
at: 'center top',
},
}, 'success', 3000);
e.preventDefault();
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.7/css/dx.light.css" />
<script src="js/dx.all.js?v=25.1.7"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<form action="your-action" id="form-container">
<div id="form"></div>
</form>
</div>
</body>
</html>
form {
margin: 10px 10px 15px;
}
.last-group {
margin-top: 30px;
margin-bottom: 10px;
}
.last-group .dx-item-content {
align-items: start;
justify-content: center;
}
.last-group .dx-field-item {
padding: 0 !important;
}
.buttons-group {
display: flex;
width: 100%;
justify-content: end;
}
.buttons-group .dx-item-content {
gap: 10px;
}
const formData = {
Email: '',
Password: '',
Name: 'Peter',
Date: null,
VacationDates: [null, null],
Country: '',
City: null,
Address: '',
Phone: '',
Accepted: false,
};
const countries = ['Afghanistan', 'Albania', 'Algeria', 'Andorra', 'Angola', 'Antigua and Barbuda', 'Argentina', 'Armenia', 'Australia', 'Austria', 'Azerbaijan', 'The Bahamas', 'Bahrain', 'Bangladesh', 'Barbados', 'Belgium', 'Belize', 'Benin', 'Bhutan', 'Bolivia', 'Bosnia and Herzegovina', 'Botswana', 'Brazil', 'Brunei', 'Bulgaria', 'Burkina Faso', 'Burma', 'Burundi', 'Cambodia', 'Cameroon', 'Canada', 'Cape Verde', 'Central African Republic', 'Chad', 'Chile', 'Colombia', 'Comoros', 'Democratic Republic of the Congo', 'Republic of the Congo', 'Costa Rica', 'Ivory Coast', 'Croatia', 'Cuba', 'Cyprus', 'Czech Republic', 'Denmark', 'Djibouti', 'Dominica', 'Dominican Republic', 'East Timor', 'Ecuador', 'Egypt', 'El Salvador', 'Equatorial Guinea', 'Eritrea', 'Estonia', 'Ethiopia', 'Fiji', 'Finland', 'France', 'Gabon', 'The Gambia', 'Georgia', 'Germany', 'Ghana', 'Greece', 'Grenada', 'Guatemala', 'Guinea', 'Guinea-Bissau', 'Guyana', 'Haiti', 'Honduras', 'Hungary', 'Iceland', 'India', 'Indonesia', 'Iraq', 'Republic of Ireland', 'Israel', 'Italy', 'Jamaica', 'Japan', 'Jordan', 'Kazakhstan', 'Kenya', 'Kiribati', 'North Korea', 'South Korea', 'Kuwait', 'Kyrgyzstan', 'Laos', 'Latvia', 'Lebanon', 'Lesotho', 'Liberia', 'Libya', 'Liechtenstein', 'Lithuania', 'Luxembourg', 'Republic of Macedonia', 'Madagascar', 'Malawi', 'Malaysia', 'Maldives', 'Mali', 'Malta', 'Marshall Islands', 'Mauritania', 'Mauritius', 'Mexico', 'Federated States of Micronesia', 'Moldova', 'Monaco', 'Mongolia', 'Montenegro', 'Morocco', 'Mozambique', 'Namibia', 'Nauru', 'Nepal', 'Kingdom of the Netherlands', 'New Zealand', 'Nicaragua', 'Niger', 'Nigeria', 'Norway', 'Oman', 'Pakistan', 'Palau', 'State of Palestine', 'Panama', 'Papua New Guinea', 'Paraguay', 'Peru', 'Philippines', 'Poland', 'Portugal', 'Qatar', 'Romania', 'Rwanda', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Vincent and the Grenadines', 'Samoa', 'San Marino', 'São Tomé and Príncipe', 'Saudi Arabia', 'Senegal', 'Serbia', 'Seychelles', 'Sierra Leone', 'Singapore', 'Slovakia', 'Slovenia', 'Solomon Islands', 'Somalia', 'South Africa', 'South Sudan', 'Spain', 'Sri Lanka', 'Sudan', 'Suriname', 'Swaziland', 'Sweden', 'Switzerland', 'Syria', 'Tajikistan', 'Tanzania', 'Thailand', 'Togo', 'Tonga', 'Trinidad and Tobago', 'Tunisia', 'Turkey', 'Turkmenistan', 'Tuvalu', 'Uganda', 'Ukraine', 'United Arab Emirates', 'United Kingdom', 'United States', 'Uruguay', 'Uzbekistan', 'Vanuatu', 'Vatican City', 'Venezuela', 'Vietnam', 'Yemen', 'Zambia', 'Zimbabwe'];
const cities = ['New York', 'Los Angeles', 'Chicago', 'Houston', 'Philadelphia', 'Phoenix', 'San Antonio', 'San Diego', 'Dallas', 'San Jose', 'Austin', 'Indianapolis', 'Jacksonville', 'San Francisco', 'Columbus', 'Charlotte', 'Fort Worth', 'Detroit', 'El Paso', 'Memphis', 'Seattle', 'Denver', 'Washington', 'Boston', 'Nashville', 'Baltimore', 'Oklahoma City', 'Louisville', 'Portland', 'Las Vegas', 'Milwaukee', 'Albuquerque', 'Tucson', 'Fresno', 'Sacramento', 'Long Beach', 'Kansas City', 'Mesa', 'Virginia Beach', 'Atlanta', 'Colorado Springs', 'Omaha', 'Raleigh', 'Miami', 'Oakland', 'Minneapolis', 'Tulsa', 'Cleveland', 'Wichita', 'Arlington', 'New Orleans', 'Bakersfield', 'Tampa', 'Honolulu', 'Aurora', 'Anaheim', 'Santa Ana', 'St. Louis', 'Riverside', 'Corpus Christi', 'Lexington', 'Pittsburgh', 'Anchorage', 'Stockton', 'Cincinnati', 'Saint Paul', 'Toledo', 'Greensboro', 'Newark', 'Plano', 'Henderson', 'Lincoln', 'Buffalo', 'Jersey City', 'Chula Vista', 'Fort Wayne', 'Orlando', 'Chandler', 'Laredo', 'Norfolk', 'Durham', 'Madison', 'Lubbock', 'Irvine', 'Winston–Salem', 'Glendale', 'Garland', 'Hialeah', 'Reno', 'Chesapeake', 'Gilbert', 'Baton Rouge', 'Irving', 'Scottsdale', 'North Las Vegas', 'Fremont', 'Boise', 'Richmond'];

<form action="your-action" (submit)="onFormSubmit($event)">
<dx-form
id="form"
(onOptionChanged)="onOptionChanged($event)"
[formData]="customer"
[readOnly]="false"
[showColonAfterLabel]="true"
[showValidationSummary]="true"
validationGroup="customerData"
>
<dxi-form-item itemType="group" caption="Credentials">
<dxi-form-item dataField="Email" [editorOptions]="emailEditorOptions">
<dxi-form-validation-rule type="required" message="Email is required">
</dxi-form-validation-rule>
<dxi-form-validation-rule type="email" message="Email is invalid">
</dxi-form-validation-rule>
<dxi-form-validation-rule
type="async"
message="Email is already registered"
[validationCallback]="asyncValidation"
>
</dxi-form-validation-rule>
</dxi-form-item>
<dxi-form-item
dataField="Password"
[editorOptions]="passwordEditorOptions"
>
<dxi-form-validation-rule
type="required"
message="Password is required"
>
</dxi-form-validation-rule>
</dxi-form-item>
<dxi-form-item
name="ConfirmPassword"
editorType="dxTextBox"
dataField="ConfirmPassword"
[editorOptions]="confirmPasswordEditorOptions"
>
<dxo-form-label text="Confirm Password"> </dxo-form-label>
<dxi-form-validation-rule
type="required"
message="Confirm Password is required"
>
</dxi-form-validation-rule>
<dxi-form-validation-rule
type="compare"
[comparisonTarget]="passwordComparison"
message="Password and Confirm Password do not match"
>
</dxi-form-validation-rule>
</dxi-form-item>
</dxi-form-item>
<dxi-form-item itemType="group" caption="Personal Data">
<dxi-form-item dataField="Name" [editorOptions]="nameEditorOptions">
<dxi-form-validation-rule type="required" message="Name is required">
</dxi-form-validation-rule>
<dxi-form-validation-rule
type="pattern"
[pattern]="namePattern"
message="Do not use digits in the Name"
>
</dxi-form-validation-rule>
</dxi-form-item>
<dxi-form-item
dataField="Date"
editorType="dxDateBox"
[editorOptions]="dateBoxOptions"
>
<dxo-form-label text="Date of birth"> </dxo-form-label>
<dxi-form-validation-rule
type="required"
message="Date of birth is required"
>
</dxi-form-validation-rule>
<dxi-form-validation-rule
type="range"
[max]="maxDate"
message="You must be at least 21 years old"
>
</dxi-form-validation-rule>
</dxi-form-item>
<dxi-form-item
dataField="VacationDates"
editorType="dxDateRangeBox"
[editorOptions]="dateRangeBoxOptions"
>
<dxo-form-label text="Vacation Dates"> </dxo-form-label>
<dxi-form-validation-rule
type="custom"
message="The vacation period must not exceed 25 days"
[validationCallback]="validateVacationDatesRange"
>
</dxi-form-validation-rule>
<dxi-form-validation-rule
type="custom"
message="Both start and end dates must be selected"
[validationCallback]="validateVacationDatesPresence"
>
</dxi-form-validation-rule>
</dxi-form-item>
</dxi-form-item>
<dxi-form-item itemType="group" caption="Billing address">
<dxi-form-item
dataField="Country"
editorType="dxSelectBox"
[editorOptions]="{ dataSource: countries }"
>
<dxi-form-validation-rule type="required" message="Country is required">
</dxi-form-validation-rule>
</dxi-form-item>
<dxi-form-item
dataField="City"
editorType="dxAutocomplete"
[editorOptions]="{ dataSource: cities, minSearchLength: 2 }"
>
<dxi-form-validation-rule
type="pattern"
[pattern]="cityPattern"
message="Do not use digits in the City name"
>
</dxi-form-validation-rule>
<dxi-form-validation-rule
type="stringLength"
[min]="2"
message="City must have at least 2 symbols"
>
</dxi-form-validation-rule>
<dxi-form-validation-rule type="required" message="City is required">
</dxi-form-validation-rule>
</dxi-form-item>
<dxi-form-item dataField="Address" [editorOptions]="addressEditorOptions">
<dxi-form-validation-rule type="required" message="Address is required">
</dxi-form-validation-rule>
</dxi-form-item>
<dxi-form-item
dataField="Phone"
helpText="Enter the phone number in USA phone format"
[editorOptions]="phoneEditorOptions"
>
<dxi-form-validation-rule
type="pattern"
[pattern]="phonePattern"
message="The phone must have a correct USA phone format"
>
</dxi-form-validation-rule>
</dxi-form-item>
</dxi-form-item>
<dxi-form-item
itemType="group"
cssClass="last-group"
[colCountByScreen]="colCountByScreen"
>
<dxi-form-item
itemType="simple"
dataField="Accepted"
editorType="dxCheckBox"
[editorOptions]="{
text: 'I agree to the Terms and Conditions',
width: 270,
value: false
}"
>
<dxo-form-label [visible]="false"> </dxo-form-label>
<dxi-form-validation-rule
type="compare"
[comparisonTarget]="checkComparison"
message="You must agree to the Terms and Conditions"
>
</dxi-form-validation-rule>
</dxi-form-item>
<dxi-form-item
itemType="group"
cssClass="buttons-group"
[colCountByScreen]="colCountByScreen"
>
<dxi-form-item
name="Reset"
itemType="button"
[buttonOptions]="resetButtonOptions"
>
</dxi-form-item>
<dxi-form-item
itemType="button"
[buttonOptions]="registerButtonOptions"
>
</dxi-form-item>
</dxi-form-item>
</dxi-form-item>
</dx-form>
</form>
import { bootstrapApplication } from '@angular/platform-browser';
import {
Component,
ViewChild,
enableProdMode,
provideZoneChangeDetection,
} from '@angular/core';
import {
DxCheckBoxModule,
DxSelectBoxModule,
DxNumberBoxModule,
DxAutocompleteModule,
} from 'devextreme-angular';
import notify from 'devextreme/ui/notify';
import Validator from 'devextreme/ui/validator';
import { AsyncRule } from 'devextreme-angular/common';
import { DxFormModule, DxFormComponent, DxFormTypes } from 'devextreme-angular/ui/form';
import { DxTextBoxTypes } from 'devextreme-angular/ui/text-box';
import { DxDateBoxTypes } from 'devextreme-angular/ui/date-box';
import { DxDateRangeBoxTypes } from 'devextreme-angular/ui/date-range-box';
import { DxButtonModule, DxButtonTypes } from 'devextreme-angular/ui/button';
import { Customer, Service } from './app.service';
type EditorOptions = DxTextBoxTypes.Properties;
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
const sendRequest = function (value) {
const invalidEmail = 'test@dx-email.com';
return new Promise((resolve) => {
setTimeout(() => {
resolve(value !== invalidEmail);
}, 1000);
});
};
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxCheckBoxModule,
DxSelectBoxModule,
DxNumberBoxModule,
DxButtonModule,
DxAutocompleteModule,
DxFormModule,
],
})
export class AppComponent {
@ViewChild(DxFormComponent, { static: false }) form: DxFormComponent;
customer: Customer;
countries: string[];
cities: string[];
maxDate: Date = new Date();
cityPattern = '^[^0-9]+$';
namePattern = /^[^0-9]+$/;
phonePattern = /^[02-9]\d{9}$/;
passwordEditorOptions: EditorOptions = {
mode: 'password',
valueChangeEvent: 'keyup',
onValueChanged: () => {
const editor = this.form.instance.getEditor('ConfirmPassword');
if (editor.option('value')) {
const instance = Validator.getInstance(editor.element()) as Validator;
instance.validate();
}
},
buttons: [
{
name: 'password',
location: 'after',
options: {
stylingMode: 'text',
icon: 'eyeopen',
onClick: () => this.changePasswordMode('Password'),
},
},
],
};
emailEditorOptions: EditorOptions = {
valueChangeEvent: 'keyup',
};
nameEditorOptions: EditorOptions = {
valueChangeEvent: 'keyup',
};
addressEditorOptions: EditorOptions = {
valueChangeEvent: 'keyup',
};
phoneEditorOptions: EditorOptions = {
mask: '+1 (X00) 000-0000',
maskRules: {
X: /[02-9]/,
},
maskInvalidMessage: 'The phone must have a correct USA phone format',
valueChangeEvent: 'keyup',
};
confirmPasswordEditorOptions: EditorOptions = {
mode: 'password',
valueChangeEvent: 'keyup',
buttons: [
{
name: 'password',
location: 'after',
options: {
icon: 'eyeopen',
stylingMode: 'text',
onClick: () => this.changePasswordMode('ConfirmPassword'),
},
},
],
};
colCountByScreen: DxFormTypes.GroupItem['colCountByScreen'] = {
xs: 2,
sm: 2,
md: 2,
lg: 2,
};
dateBoxOptions: DxDateBoxTypes.Properties = {
placeholder: 'Birth Date',
acceptCustomValue: false,
openOnFieldClick: true,
};
dateRangeBoxOptions: DxDateRangeBoxTypes.Properties = {
startDatePlaceholder: 'Start Date',
endDatePlaceholder: 'End Date',
acceptCustomValue: false,
};
registerButtonOptions: DxButtonTypes.Properties = {
text: 'Register',
type: 'default',
width: '120px',
useSubmitBehavior: true,
};
resetButtonOptions: DxButtonTypes.Properties = {
text: 'Reset',
width: '120px',
disabled: true,
icon: 'refresh',
onClick: () => {
this.form.instance.reset();
},
};
constructor(service: Service) {
this.maxDate = new Date(this.maxDate.setFullYear(this.maxDate.getFullYear() - 21));
this.countries = service.getCountries();
this.cities = service.getCities();
this.customer = service.getCustomer();
}
passwordComparison = () => this.form.instance.option('formData').Password;
checkComparison() {
return true;
}
changePasswordMode = (name: string) => {
const editor = this.form.instance.getEditor(name);
editor.option(
'mode',
editor.option('mode') === 'text' ? 'password' : 'text',
);
};
validateVacationDatesRange({ value }) {
const [startDate, endDate] = value;
if (startDate === null || endDate === null) {
return true;
}
const millisecondsPerDay = 24 * 60 * 60 * 1000;
const daysDifference = Math.abs((endDate - startDate) / millisecondsPerDay);
return daysDifference < 25;
}
validateVacationDatesPresence({ value }) {
const [startDate, endDate] = value;
if (startDate === null && endDate === null) {
return true;
}
return startDate !== null && endDate !== null;
}
asyncValidation: AsyncRule['validationCallback'] = ({ value }) => sendRequest(value);
onFormSubmit = (e: SubmitEvent) => {
notify({
message: 'You have submitted the form',
position: {
my: 'center top',
at: 'center top',
},
}, 'success', 3000);
e.preventDefault();
};
onOptionChanged = (e: DxFormTypes.OptionChangedEvent) => {
if (e.name === 'isDirty') {
const resetButton = this.form.instance.getButton('Reset');
resetButton.option('disabled', !e.value);
}
};
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep form {
margin: 10px 10px 15px;
}
::ng-deep .last-group {
margin-top: 30px;
margin-bottom: 10px;
}
::ng-deep .last-group .dx-item-content {
align-items: start;
justify-content: center;
}
::ng-deep .last-group .dx-field-item {
padding: 0 !important;
}
::ng-deep .buttons-group {
display: flex;
width: 100%;
justify-content: end;
}
::ng-deep .buttons-group .dx-item-content {
gap: 10px;
}
import { Injectable } from '@angular/core';
export class Customer {
Email: string;
Password: string;
Name: string;
Date: Date;
VacationDates: [Date, Date];
Country: string;
City: string;
Address: string;
Phone: string;
Accepted: boolean;
}
const customer: Customer = {
Email: '',
Password: '',
Name: 'Peter',
Date: null,
VacationDates: [null, null],
Country: '',
City: null,
Address: '',
Phone: '',
Accepted: false,
};
const countries: string[] = ['Afghanistan', 'Albania', 'Algeria', 'Andorra', 'Angola', 'Antigua and Barbuda', 'Argentina', 'Armenia', 'Australia', 'Austria', 'Azerbaijan', 'The Bahamas', 'Bahrain', 'Bangladesh', 'Barbados', 'Belgium', 'Belize', 'Benin', 'Bhutan', 'Bolivia', 'Bosnia and Herzegovina', 'Botswana', 'Brazil', 'Brunei', 'Bulgaria', 'Burkina Faso', 'Burma', 'Burundi', 'Cambodia', 'Cameroon', 'Canada', 'Cape Verde', 'Central African Republic', 'Chad', 'Chile', 'Colombia', 'Comoros', 'Democratic Republic of the Congo', 'Republic of the Congo', 'Costa Rica', 'Ivory Coast', 'Croatia', 'Cuba', 'Cyprus', 'Czech Republic', 'Denmark', 'Djibouti', 'Dominica', 'Dominican Republic', 'East Timor', 'Ecuador', 'Egypt', 'El Salvador', 'Equatorial Guinea', 'Eritrea', 'Estonia', 'Ethiopia', 'Fiji', 'Finland', 'France', 'Gabon', 'The Gambia', 'Georgia', 'Germany', 'Ghana', 'Greece', 'Grenada', 'Guatemala', 'Guinea', 'Guinea-Bissau', 'Guyana', 'Haiti', 'Honduras', 'Hungary', 'Iceland', 'India', 'Indonesia', 'Iraq', 'Republic of Ireland', 'Israel', 'Italy', 'Jamaica', 'Japan', 'Jordan', 'Kazakhstan', 'Kenya', 'Kiribati', 'North Korea', 'South Korea', 'Kuwait', 'Kyrgyzstan', 'Laos', 'Latvia', 'Lebanon', 'Lesotho', 'Liberia', 'Libya', 'Liechtenstein', 'Lithuania', 'Luxembourg', 'Republic of Macedonia', 'Madagascar', 'Malawi', 'Malaysia', 'Maldives', 'Mali', 'Malta', 'Marshall Islands', 'Mauritania', 'Mauritius', 'Mexico', 'Federated States of Micronesia', 'Moldova', 'Monaco', 'Mongolia', 'Montenegro', 'Morocco', 'Mozambique', 'Namibia', 'Nauru', 'Nepal', 'Kingdom of the Netherlands', 'New Zealand', 'Nicaragua', 'Niger', 'Nigeria', 'Norway', 'Oman', 'Pakistan', 'Palau', 'State of Palestine', 'Panama', 'Papua New Guinea', 'Paraguay', 'Peru', 'Philippines', 'Poland', 'Portugal', 'Qatar', 'Romania', 'Rwanda', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Vincent and the Grenadines', 'Samoa', 'San Marino', 'São Tomé and Príncipe', 'Saudi Arabia', 'Senegal', 'Serbia', 'Seychelles', 'Sierra Leone', 'Singapore', 'Slovakia', 'Slovenia', 'Solomon Islands', 'Somalia', 'South Africa', 'South Sudan', 'Spain', 'Sri Lanka', 'Sudan', 'Suriname', 'Swaziland', 'Sweden', 'Switzerland', 'Syria', 'Tajikistan', 'Tanzania', 'Thailand', 'Togo', 'Tonga', 'Trinidad and Tobago', 'Tunisia', 'Turkey', 'Turkmenistan', 'Tuvalu', 'Uganda', 'Ukraine', 'United Arab Emirates', 'United Kingdom', 'United States', 'Uruguay', 'Uzbekistan', 'Vanuatu', 'Vatican City', 'Venezuela', 'Vietnam', 'Yemen', 'Zambia', 'Zimbabwe'];
const cities: string[] = ['New York', 'Los Angeles', 'Chicago', 'Houston', 'Philadelphia', 'Phoenix', 'San Antonio', 'San Diego', 'Dallas', 'San Jose', 'Austin', 'Indianapolis', 'Jacksonville', 'San Francisco', 'Columbus', 'Charlotte', 'Fort Worth', 'Detroit', 'El Paso', 'Memphis', 'Seattle', 'Denver', 'Washington', 'Boston', 'Nashville', 'Baltimore', 'Oklahoma City', 'Louisville', 'Portland', 'Las Vegas', 'Milwaukee', 'Albuquerque', 'Tucson', 'Fresno', 'Sacramento', 'Long Beach', 'Kansas City', 'Mesa', 'Virginia Beach', 'Atlanta', 'Colorado Springs', 'Omaha', 'Raleigh', 'Miami', 'Oakland', 'Minneapolis', 'Tulsa', 'Cleveland', 'Wichita', 'Arlington', 'New Orleans', 'Bakersfield', 'Tampa', 'Honolulu', 'Aurora', 'Anaheim', 'Santa Ana', 'St. Louis', 'Riverside', 'Corpus Christi', 'Lexington', 'Pittsburgh', 'Anchorage', 'Stockton', 'Cincinnati', 'Saint Paul', 'Toledo', 'Greensboro', 'Newark', 'Plano', 'Henderson', 'Lincoln', 'Buffalo', 'Jersey City', 'Chula Vista', 'Fort Wayne', 'Orlando', 'Chandler', 'Laredo', 'Norfolk', 'Durham', 'Madison', 'Lubbock', 'Irvine', 'Winston–Salem', 'Glendale', 'Garland', 'Hialeah', 'Reno', 'Chesapeake', 'Gilbert', 'Baton Rouge', 'Irving', 'Scottsdale', 'North Las Vegas', 'Fremont', 'Boise', 'Richmond'];
@Injectable()
export class Service {
getCustomer(): Customer {
return customer;
}
getCountries() {
return countries;
}
getCities() {
return cities;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.24/package.json',
'npm:devexpress-gantt@4.1.64/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.0.8"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div id="form-demo">
<div class="widget-container">
<form
action="your-action"
@submit="handleSubmit"
>
<DxForm
v-model:form-data="customer"
:read-only="false"
:show-colon-after-label="true"
:show-validation-summary="true"
validation-group="customerData"
>
<DxGroupItem caption="Credentials">
<DxSimpleItem data-field="Email">
<DxRequiredRule message="Email is required"/>
<DxEmailRule message="Email is invalid"/>
<DxAsyncRule
:validation-callback="asyncValidation"
message="Email is already registered"
/>
</DxSimpleItem>
<DxSimpleItem
:editor-options="passwordOptions"
data-field="Password"
>
<DxRequiredRule message="Password is required"/>
</DxSimpleItem>
<DxSimpleItem
:editor-options="passwordOptions"
editor-type="dxTextBox"
>
<DxLabel text="Confirm Password"/>
<DxRequiredRule message="Confirm Password is required"/>
<DxCompareRule
:comparison-target="passwordComparison"
message="Password and Confirm Password do not match"
/>
</DxSimpleItem>
</DxGroupItem>
<DxGroupItem caption="Personal Data">
<DxSimpleItem data-field="Name">
<DxRequiredRule message="Name is required"/>
<DxPatternRule
:pattern="namePattern"
message="Do not use digits in the Name"
/>
</DxSimpleItem>
<DxSimpleItem
:editor-options="dateBoxOptions"
data-field="Date"
editor-type="dxDateBox"
>
<DxLabel text="Date of birth"/>
<DxRequiredRule message="Date of birth is required"/>
<DxRangeRule
:max="maxDate"
message="You must be at least 21 years old"
/>
</DxSimpleItem>
</DxGroupItem>
<DxGroupItem caption="Billing address">
<DxSimpleItem
:editor-options="countryEditorOptions"
data-field="Country"
editor-type="dxSelectBox"
>
<DxRequiredRule message="Country is required"/>
</DxSimpleItem>
<DxSimpleItem
:editor-options="cityEditorOptions"
data-field="City"
editor-type="dxAutocomplete"
>
<DxPatternRule
:pattern="cityPattern"
message="Do not use digits in the City name"
/>
<DxStringLengthRule
:min="2"
message="City must have at least 2 symbols"
/>
<DxRequiredRule message="City is required"/>
</DxSimpleItem>
<DxSimpleItem data-field="Address">
<DxRequiredRule message="Address is required"/>
</DxSimpleItem>
<DxSimpleItem
:editor-options="phoneEditorOptions"
data-field="Phone"
help-text="Enter the phone number in USA phone format"
>
<DxPatternRule
:pattern="phonePattern"
message="The phone must have a correct USA phone format"
/>
</DxSimpleItem>
<DxSimpleItem
:editor-options="checkBoxOptions"
data-field="Accepted"
editor-type="dxCheckBox"
>
<DxLabel :visible="false"/>
<DxCompareRule
:comparison-target="checkComparison"
type="compare"
message="You must agree to the Terms and Conditions"
/>
</DxSimpleItem>
</DxGroupItem>
<DxButtonItem
:button-options="buttonOptions"
horizontal-alignment="left"
/>
</DxForm>
</form>
</div>
</div>
</template>
<script>
import DxForm, {
DxGroupItem,
DxSimpleItem,
DxButtonItem,
DxLabel,
DxRequiredRule,
DxCompareRule,
DxRangeRule,
DxStringLengthRule,
DxPatternRule,
DxEmailRule,
DxAsyncRule,
} from 'devextreme-vue/form';
import DxAutocomplete from 'devextreme-vue/autocomplete';
import notify from 'devextreme/ui/notify';
import service from './data.js';
const sendRequest = function(value) {
const invalidEmail = 'test@dx-email.com';
return new Promise((resolve) => {
setTimeout(() => {
resolve(value !== invalidEmail);
}, 1000);
});
};
export default {
components: {
DxGroupItem,
DxSimpleItem,
DxButtonItem,
DxLabel,
DxRequiredRule,
DxCompareRule,
DxPatternRule,
DxRangeRule,
DxEmailRule,
DxStringLengthRule,
DxForm,
DxAutocomplete,
DxAsyncRule,
notify,
},
data() {
return {
customer: service.getCustomer(),
buttonOptions: {
text: 'Register',
type: 'success',
useSubmitBehavior: true,
},
passwordOptions: {
mode: 'password',
},
dateBoxOptions: {
invalidDateMessage:
'The date must have the following format: MM/dd/yyyy',
},
checkBoxOptions: {
text: 'I agree to the Terms and Conditions',
value: false,
},
phoneEditorOptions: {
mask: '+1 (X00) 000-0000',
maskRules: {
X: /[02-9]/,
},
maskInvalidMessage: 'The phone must have a correct USA phone format',
},
cityEditorOptions: {
dataSource: service.getCities(),
minSearchLength: 2,
},
countryEditorOptions: {
dataSource: service.getCountries(),
},
maxDate: new Date().setFullYear(new Date().getFullYear() - 21),
namePattern: /^[^0-9]+$/,
cityPattern: /^[^0-9]+$/,
phonePattern: /^[02-9]\d{9}$/,
};
},
methods: {
passwordComparison() {
return this.customer.Password;
},
checkComparison() {
return true;
},
asyncValidation(params) {
return sendRequest(params.value);
},
handleSubmit(e) {
notify({
message: 'You have submitted the form',
position: {
my: 'center top',
at: 'center top',
},
}, 'success', 3000);
e.preventDefault();
},
},
};
</script>
<style scoped>
form {
margin: 10px;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
const customer = {
Email: '',
Password: '',
Name: 'Peter',
Date: null,
Country: '',
City: '',
Address: '',
Phone: '',
Accepted: false,
};
const countries = [
'Afghanistan', 'Albania', 'Algeria', 'Andorra', 'Angola', 'Antigua and Barbuda', 'Argentina', 'Armenia', 'Australia', 'Austria', 'Azerbaijan', 'The Bahamas', 'Bahrain', 'Bangladesh', 'Barbados', 'Belarus', 'Belgium', 'Belize', 'Benin', 'Bhutan', 'Bolivia', 'Bosnia and Herzegovina', 'Botswana', 'Brazil', 'Brunei', 'Bulgaria', 'Burkina Faso', 'Burma', 'Burundi', 'Cambodia', 'Cameroon', 'Canada', 'Cape Verde', 'Central African Republic', 'Chad', 'Chile', 'China', 'Colombia', 'Comoros', 'Democratic Republic of the Congo', 'Republic of the Congo', 'Costa Rica', 'Ivory Coast', 'Croatia', 'Cuba', 'Cyprus', 'Czech Republic', 'Denmark', 'Djibouti', 'Dominica', 'Dominican Republic', 'East Timor', 'Ecuador', 'Egypt', 'El Salvador', 'Equatorial Guinea', 'Eritrea', 'Estonia', 'Ethiopia', 'Fiji', 'Finland', 'France', 'Gabon', 'The Gambia', 'Georgia', 'Germany', 'Ghana', 'Greece', 'Grenada', 'Guatemala', 'Guinea', 'Guinea-Bissau', 'Guyana', 'Haiti', 'Honduras', 'Hungary', 'Iceland', 'India', 'Indonesia', 'Iran', 'Iraq', 'Republic of Ireland', 'Israel', 'Italy', 'Jamaica', 'Japan', 'Jordan', 'Kazakhstan', 'Kenya', 'Kiribati', 'North Korea', 'South Korea', 'Kuwait', 'Kyrgyzstan', 'Laos', 'Latvia', 'Lebanon', 'Lesotho', 'Liberia', 'Libya', 'Liechtenstein', 'Lithuania', 'Luxembourg', 'Republic of Macedonia', 'Madagascar', 'Malawi', 'Malaysia', 'Maldives', 'Mali', 'Malta', 'Marshall Islands', 'Mauritania', 'Mauritius', 'Mexico', 'Federated States of Micronesia', 'Moldova', 'Monaco', 'Mongolia', 'Montenegro', 'Morocco', 'Mozambique', 'Namibia', 'Nauru', 'Nepal', 'Kingdom of the Netherlands', 'New Zealand', 'Nicaragua', 'Niger', 'Nigeria', 'Norway', 'Oman', 'Pakistan', 'Palau', 'State of Palestine', 'Panama', 'Papua New Guinea', 'Paraguay', 'Peru', 'Philippines', 'Poland', 'Portugal', 'Qatar', 'Romania', 'Russia', 'Rwanda', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Vincent and the Grenadines', 'Samoa', 'San Marino', 'São Tomé and Príncipe', 'Saudi Arabia', 'Senegal', 'Serbia', 'Seychelles', 'Sierra Leone', 'Singapore', 'Slovakia', 'Slovenia', 'Solomon Islands', 'Somalia', 'South Africa', 'South Sudan', 'Spain', 'Sri Lanka', 'Sudan', 'Suriname', 'Swaziland', 'Sweden', 'Switzerland', 'Syria', 'Tajikistan', 'Tanzania', 'Thailand', 'Togo', 'Tonga', 'Trinidad and Tobago', 'Tunisia', 'Turkey', 'Turkmenistan', 'Tuvalu', 'Uganda', 'Ukraine', 'United Arab Emirates', 'United Kingdom', 'United States', 'Uruguay', 'Uzbekistan', 'Vanuatu', 'Vatican City', 'Venezuela', 'Vietnam', 'Yemen', 'Zambia', 'Zimbabwe'];
const cities = [
'New York', 'Los Angeles', 'Chicago', 'Houston', 'Philadelphia', 'Phoenix', 'San Antonio', 'San Diego', 'Dallas', 'San Jose', 'Austin', 'Indianapolis', 'Jacksonville', 'San Francisco', 'Columbus', 'Charlotte', 'Fort Worth', 'Detroit', 'El Paso', 'Memphis', 'Seattle', 'Denver', 'Washington', 'Boston', 'Nashville', 'Baltimore', 'Oklahoma City', 'Louisville', 'Portland', 'Las Vegas', 'Milwaukee', 'Albuquerque', 'Tucson', 'Fresno', 'Sacramento', 'Long Beach', 'Kansas City', 'Mesa', 'Virginia Beach', 'Atlanta', 'Colorado Springs', 'Omaha', 'Raleigh', 'Miami', 'Oakland', 'Minneapolis', 'Tulsa', 'Cleveland', 'Wichita', 'Arlington', 'New Orleans', 'Bakersfield', 'Tampa', 'Honolulu', 'Aurora', 'Anaheim', 'Santa Ana', 'St. Louis', 'Riverside', 'Corpus Christi', 'Lexington', 'Pittsburgh', 'Anchorage', 'Stockton', 'Cincinnati', 'Saint Paul', 'Toledo', 'Greensboro', 'Newark', 'Plano', 'Henderson', 'Lincoln', 'Buffalo', 'Jersey City', 'Chula Vista', 'Fort Wayne', 'Orlando', 'St. Petersburg', 'Chandler', 'Laredo', 'Norfolk', 'Durham', 'Madison', 'Lubbock', 'Irvine', 'Winston–Salem', 'Glendale', 'Garland', 'Hialeah', 'Reno', 'Chesapeake', 'Gilbert', 'Baton Rouge', 'Irving', 'Scottsdale', 'North Las Vegas', 'Fremont', 'Boise', 'Richmond'];
export default {
getCustomer() {
return customer;
},
getCountries() {
return countries;
},
getCities() {
return cities;
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.2.41/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme-vue': 'npm:devextreme-vue@22.2.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.18/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

Your search did not match any results.
Form

Validation

This demo shows how to validate Form editors. To apply validation rules to an editor, declare them in the validationRules[] array. Specify type and other properties for each rule.

The following validation rules are shown in this demo:

  • RequiredRule
    Requires that a validated editor has a value.

  • CompareRule
    Compares the editor's value to the specified expression.

  • PatternRule
    Checks whether an editor value matches a specified pattern.

  • RangeRule
    Checks whether an editor value is in a specified range.

  • StringLengthRule
    Requires that an editor value length is in a specified range.

  • EmailRule
    Requires that an editor value matches the Email pattern.

  • AsyncRule
    Allows you to add custom server-side validation logic. Rules of this type run last, only if all other rules passed. In this demo, an AsyncRule checks whether user input matches test@dx-email.com.

To submit form data, do the following:

  1. Wrap the Form component in the HTML <form> element.

  2. Use the Button Form Item to add a button to the form. This button submits the form data.

  3. Enable the button's useSubmitBehavior property.

When users click the button, the Form validates all editors that belong to the same validationGroup as this button. In this demo, all these editors belong to the customerData group. Form data can be submitted to a server only if input validation is successful. Enable the showValidationSummary property to display all validation errors at the bottom of the Form.

Backend API
Copy to CodeSandBox
Apply
Reset
import React from 'react'; import Form, { ButtonItem, GroupItem, SimpleItem, Label, CompareRule, EmailRule, PatternRule, RangeRule, RequiredRule, StringLengthRule, AsyncRule, } from 'devextreme-react/form'; import notify from 'devextreme/ui/notify'; import 'devextreme-react/autocomplete'; import service from './data.js'; class App extends React.Component { constructor() { super(); this.buttonOptions = { text: 'Register', type: 'success', useSubmitBehavior: true, }; this.checkBoxOptions = { text: 'I agree to the Terms and Conditions', value: false, }; this.cityEditorOptions = { dataSource: service.getCities(), minSearchLength: 2, }; this.countryEditorOptions = { dataSource: service.getCountries(), }; this.passwordOptions = { mode: 'password', }; this.phoneEditorOptions = { mask: '+1 (X00) 000-0000', maskRules: { X: /[02-9]/, }, maskInvalidMessage: 'The phone must have a correct USA phone format', }; this.maxDate = new Date().setFullYear(new Date().getFullYear() - 21); this.dateBoxOptions = { invalidDateMessage: 'The date must have the following format: MM/dd/yyyy', }; this.state = { customer: service.getCustomer(), }; this.handleSubmit = this.handleSubmit.bind(this); this.passwordComparison = this.passwordComparison.bind(this); } render() { const { customer, } = this.state; return ( <React.Fragment> <form action="your-action" onSubmit={this.handleSubmit}> <Form formData={customer} readOnly={false} showColonAfterLabel={true} showValidationSummary={true} validationGroup="customerData" > <GroupItem caption="Credentials"> <SimpleItem dataField="Email" editorType="dxTextBox"> <RequiredRule message="Email is required" /> <EmailRule message="Email is invalid" /> <AsyncRule message="Email is already registered" validationCallback={asyncValidation} /> </SimpleItem> <SimpleItem dataField="Password" editorType="dxTextBox" editorOptions={this.passwordOptions}> <RequiredRule message="Password is required" /> </SimpleItem> <SimpleItem editorType="dxTextBox" editorOptions={this.passwordOptions}> <Label text="Confirm Password" /> <RequiredRule message="Confirm Password is required" /> <CompareRule message="Password and Confirm Password do not match" comparisonTarget={this.passwordComparison} /> </SimpleItem> </GroupItem> <GroupItem caption="Personal Data"> <SimpleItem dataField="Name"> <RequiredRule message="Name is required" /> <PatternRule message="Do not use digits in the Name" pattern={/^[^0-9]+$/} /> </SimpleItem> <SimpleItem dataField="Date" editorType="dxDateBox" editorOptions={this.dateBoxOptions}> <Label text="Date of birth" /> <RequiredRule message="Date of birth is required" /> <RangeRule max={this.maxDate} message="You must be at least 21 years old" /> </SimpleItem> </GroupItem> <GroupItem caption="Billing address"> <SimpleItem dataField="Country" editorType="dxSelectBox" editorOptions={this.countryEditorOptions}> <RequiredRule message="Country is required" /> </SimpleItem> <SimpleItem dataField="City" editorType="dxAutocomplete" editorOptions={this.cityEditorOptions}> <PatternRule pattern={/^[^0-9]+$/} message="Do not use digits in the City name" /> <StringLengthRule min={2} message="City must have at least 2 symbols" /> <RequiredRule message="City is required" /> </SimpleItem> <SimpleItem dataField="Address"> <RequiredRule message="Address is required" /> </SimpleItem> <SimpleItem dataField="Phone" helpText="Enter the phone number in USA phone format" editorOptions={this.phoneEditorOptions} > <PatternRule message="The phone must have a correct USA phone format" pattern={/^[02-9]\d{9}$/} /> </SimpleItem> <SimpleItem dataField="Accepted" editorType="dxCheckBox" editorOptions={this.checkBoxOptions}> <Label visible={false} /> <CompareRule message="You must agree to the Terms and Conditions" comparisonTarget={this.checkComparison} /> </SimpleItem> </GroupItem> <ButtonItem horizontalAlignment="left" buttonOptions={this.buttonOptions} /> </Form> </form> </React.Fragment> ); } checkComparison() { return true; } handleSubmit(e) { notify({ message: 'You have submitted the form', position: { my: 'center top', at: 'center top', }, }, 'success', 3000); e.preventDefault(); } passwordComparison() { return this.state.customer.Password; } } function sendRequest(value) { const invalidEmail = 'test@dx-email.com'; return new Promise((resolve) => { setTimeout(() => { resolve(value !== invalidEmail); }, 1000); }); } function asyncValidation(params) { return sendRequest(params.value); } export default App;
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render( <App />, document.getElementById('app'), );
<!DOCTYPE html> <html> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.js"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
form { margin: 10px; }
const customer = { Email: '', Password: '', Name: 'Peter', Date: null, Country: '', City: '', Address: '', Phone: '', Accepted: false, }; const countries = [ 'Afghanistan', 'Albania', 'Algeria', 'Andorra', 'Angola', 'Antigua and Barbuda', 'Argentina', 'Armenia', 'Australia', 'Austria', 'Azerbaijan', 'The Bahamas', 'Bahrain', 'Bangladesh', 'Barbados', 'Belarus', 'Belgium', 'Belize', 'Benin', 'Bhutan', 'Bolivia', 'Bosnia and Herzegovina', 'Botswana', 'Brazil', 'Brunei', 'Bulgaria', 'Burkina Faso', 'Burma', 'Burundi', 'Cambodia', 'Cameroon', 'Canada', 'Cape Verde', 'Central African Republic', 'Chad', 'Chile', 'China', 'Colombia', 'Comoros', 'Democratic Republic of the Congo', 'Republic of the Congo', 'Costa Rica', 'Ivory Coast', 'Croatia', 'Cuba', 'Cyprus', 'Czech Republic', 'Denmark', 'Djibouti', 'Dominica', 'Dominican Republic', 'East Timor', 'Ecuador', 'Egypt', 'El Salvador', 'Equatorial Guinea', 'Eritrea', 'Estonia', 'Ethiopia', 'Fiji', 'Finland', 'France', 'Gabon', 'The Gambia', 'Georgia', 'Germany', 'Ghana', 'Greece', 'Grenada', 'Guatemala', 'Guinea', 'Guinea-Bissau', 'Guyana', 'Haiti', 'Honduras', 'Hungary', 'Iceland', 'India', 'Indonesia', 'Iran', 'Iraq', 'Republic of Ireland', 'Israel', 'Italy', 'Jamaica', 'Japan', 'Jordan', 'Kazakhstan', 'Kenya', 'Kiribati', 'North Korea', 'South Korea', 'Kuwait', 'Kyrgyzstan', 'Laos', 'Latvia', 'Lebanon', 'Lesotho', 'Liberia', 'Libya', 'Liechtenstein', 'Lithuania', 'Luxembourg', 'Republic of Macedonia', 'Madagascar', 'Malawi', 'Malaysia', 'Maldives', 'Mali', 'Malta', 'Marshall Islands', 'Mauritania', 'Mauritius', 'Mexico', 'Federated States of Micronesia', 'Moldova', 'Monaco', 'Mongolia', 'Montenegro', 'Morocco', 'Mozambique', 'Namibia', 'Nauru', 'Nepal', 'Kingdom of the Netherlands', 'New Zealand', 'Nicaragua', 'Niger', 'Nigeria', 'Norway', 'Oman', 'Pakistan', 'Palau', 'State of Palestine', 'Panama', 'Papua New Guinea', 'Paraguay', 'Peru', 'Philippines', 'Poland', 'Portugal', 'Qatar', 'Romania', 'Russia', 'Rwanda', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Vincent and the Grenadines', 'Samoa', 'San Marino', 'São Tomé and Príncipe', 'Saudi Arabia', 'Senegal', 'Serbia', 'Seychelles', 'Sierra Leone', 'Singapore', 'Slovakia', 'Slovenia', 'Solomon Islands', 'Somalia', 'South Africa', 'South Sudan', 'Spain', 'Sri Lanka', 'Sudan', 'Suriname', 'Swaziland', 'Sweden', 'Switzerland', 'Syria', 'Tajikistan', 'Tanzania', 'Thailand', 'Togo', 'Tonga', 'Trinidad and Tobago', 'Tunisia', 'Turkey', 'Turkmenistan', 'Tuvalu', 'Uganda', 'Ukraine', 'United Arab Emirates', 'United Kingdom', 'United States', 'Uruguay', 'Uzbekistan', 'Vanuatu', 'Vatican City', 'Venezuela', 'Vietnam', 'Yemen', 'Zambia', 'Zimbabwe']; const cities = [ 'New York', 'Los Angeles', 'Chicago', 'Houston', 'Philadelphia', 'Phoenix', 'San Antonio', 'San Diego', 'Dallas', 'San Jose', 'Austin', 'Indianapolis', 'Jacksonville', 'San Francisco', 'Columbus', 'Charlotte', 'Fort Worth', 'Detroit', 'El Paso', 'Memphis', 'Seattle', 'Denver', 'Washington', 'Boston', 'Nashville', 'Baltimore', 'Oklahoma City', 'Louisville', 'Portland', 'Las Vegas', 'Milwaukee', 'Albuquerque', 'Tucson', 'Fresno', 'Sacramento', 'Long Beach', 'Kansas City', 'Mesa', 'Virginia Beach', 'Atlanta', 'Colorado Springs', 'Omaha', 'Raleigh', 'Miami', 'Oakland', 'Minneapolis', 'Tulsa', 'Cleveland', 'Wichita', 'Arlington', 'New Orleans', 'Bakersfield', 'Tampa', 'Honolulu', 'Aurora', 'Anaheim', 'Santa Ana', 'St. Louis', 'Riverside', 'Corpus Christi', 'Lexington', 'Pittsburgh', 'Anchorage', 'Stockton', 'Cincinnati', 'Saint Paul', 'Toledo', 'Greensboro', 'Newark', 'Plano', 'Henderson', 'Lincoln', 'Buffalo', 'Jersey City', 'Chula Vista', 'Fort Wayne', 'Orlando', 'St. Petersburg', 'Chandler', 'Laredo', 'Norfolk', 'Durham', 'Madison', 'Lubbock', 'Irvine', 'Winston–Salem', 'Glendale', 'Garland', 'Hialeah', 'Reno', 'Chesapeake', 'Gilbert', 'Baton Rouge', 'Irving', 'Scottsdale', 'North Las Vegas', 'Fremont', 'Boise', 'Richmond']; export default { getCustomer() { return customer; }, getCountries() { return countries; }, getCities() { return cities; }, };
window.config = { transpiler: 'plugin-babel', meta: { 'devextreme/localization.js': { 'esModule': true, }, }, paths: { 'npm:': 'https://unpkg.com/', }, defaultExtension: 'js', map: { 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types@15.8.1/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@22.2.3/cjs', 'devextreme-react': 'npm:devextreme-react@22.2.3', 'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.7.1/standalone.js', 'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.11/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; System.config(window.config);